import numpy as np

# reseni transcendentni rovnice metodou puleni intervalu
def solve_bisect(f,a,b,acc,maxiter):
 
    x1=a
    f1=f(a)
    x2=b
    f2=f(b)

    for iter in range(maxiter):
        x=(x1+x2)/2
        fx=f(x)
        if fx==0.0 or x2-x1<=acc: break
        if fx*f1<0.0:
            x2=x
            f2=fx
        else:
            x1=x
            f1=fx
            
    return x
    
# reseni transcendentni rovnice Riddersovou metodou
def solve_Ridders(f,a,b,acc,maxiter):
    
    x1=a
    f1=f(a)
    x2=b
    f2=f(b)
    xold=1e100
    
    for iter in range(maxiter):
        x3=(x1+x2)/2
        f3=f(x3)
        x=x3+(x3-x1)*np.sign(f1-f2)*f3/np.sqrt(f3**2-f1*f2)
        fx=f(x)
        if fx==0.0 or abs(x-xold)<=acc: break
        if f3*fx<0.0:
            x1=x3
            f1=f3
            x2=x
            f2=fx
        elif fx*f1<0.0:
            x2=x
            f2=fx
        else:
            x1=x
            f1=fx
        xold=x
        
    return x

#----------------------------------------------------------

def fun(x): return x-np.cos(x)

x=solve_bisect(fun,0.0,1.0,1e-9,20)
print(x,fun(x))

x=solve_Ridders(fun,0.0,1.0,1e-9,20)
print(x,fun(x))